<?php
/**
* Auteur : Félix Dr. Dimitric
* Date du plug-in : 08/12/2017
* Ce plugin est basé sur le script http://www.kommunauty.fr/article-727-javascript-de-la-neige-sur-vos-sites-web
* License : GNU/GPL (Plus d'informations sur ce qu'est la license GNU/GPL ici : http://www.gnu.org/copyleft/gpl.html)
* Version 2.0
*/

// Code de sécurité
defined( '_JEXEC' ) or die( 'Restricted access' );

// Importe les routines du plugin
jimport( 'joomla.plugin.plugin');

class plgContentbeautifulsnow extends JPlugin
{
    function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
			}
	public function onContentPrepare($context, &$article, &$params)
	{
		// Détermine le tag qui sera utilisé pour activer le plugin
		if (JString::strpos($article->text, 'snow') === false) {
			return true;
		}
		$regex = "#{snow}(.*?){/snow}#s";	
		
	// Routine de remplacement
	$article->text = preg_replace_callback($regex, array(&$this,'modification'), $article->text);

		return true;
		
		$article->text = preg_replace( $regex, '', $article->text );
			
		return true;
					
	    // Recherche les instances définis
		preg_match_all( $regex, $article->text, $matches );

		// Compte le nombre d'instances
	 	$count = count( $matches[0] );	
 		 	
	}
	
	// Remplace la syntaxe définit par le code final
      function modification (&$matches) 
	{
        $id= $matches[1];
		
	// Consulte et applique les paramètres du fichier *.xml
    $plugin = JPluginHelper::getPlugin('content', 'beautifulsnow');
// Regarde si le plugin est activé
if ($plugin)
{
    // Consulte les paramètres
    $pluginParams = new JRegistry($plugin->params);
	$nombre = $pluginParams->get('nombre'); 
    $wind = $pluginParams->get('wind');
    $vitessemaxi = $pluginParams->get('vitessemaxi');
	$vitessemini = $pluginParams->get('vitessemini');  
    $symbole = $pluginParams->get('symbole');
    $taillemaxi = $pluginParams->get('taillemaxi'); 
    $taillemini = $pluginParams->get('taillemini');
    $couleur = $pluginParams->get('couleur');  	
	}
	// lance le script demandé
        $html = '<script type="text/javascript">
			window.onload = function(){
				snow.init('.$nombre.');
			};
var snow = {
          
    wind : '.$wind.',
	maxXrange : 100,
	minXrange : 10,
	maxSpeed : '.$vitessemaxi.',
	minSpeed : '.$vitessemini.',
	color : "'.$couleur.'",
	char : "'.$symbole.'",
	maxSize : '.$taillemaxi.',
	minSize : '.$taillemini.',

	flakes : [],
	WIDTH : 0,
	HEIGHT : 0,

	init : function(nb){
		var o = this,
			frag = document.createDocumentFragment();
		o.getSize();
		window.onresize = function(){o.getSize();};		

		for(var i = 0; i < nb; i++){
			var flake = {
				x : o.random(o.WIDTH),
				y : - o.maxSize,
				xrange : o.minXrange + o.random(o.maxXrange - o.minXrange),
				yspeed : o.minSpeed + o.random(o.maxSpeed - o.minSpeed, 100),
				life : 0,
				size : o.minSize + o.random(o.maxSize - o.minSize),
				html : document.createElement("span")
			};

			flake.html.style.position = "absolute";
			flake.html.style.top = flake.y + "px";
			flake.html.style.left = flake.x + "px";
			flake.html.style.fontSize = flake.size + "px";
			flake.html.style.color = o.color;
			flake.html.appendChild(document.createTextNode(o.char));

			frag.appendChild(flake.html);
			o.flakes.push(flake);
		}

		document.body.appendChild(frag);
		o.animate();
	},

	animate : function(){
		var o = this;
		for(var i = 0, c = o.flakes.length; i < c; i++){
			var flake = o.flakes[i],
				top = flake.y + flake.yspeed,
				left = flake.x + Math.sin(flake.life) * flake.xrange + o.wind;
			if(top < o.HEIGHT - flake.size - 10 && left < o.WIDTH - flake.size && left > 0){
				flake.html.style.top = top + "px";
				flake.html.style.left = left + "px";
				flake.y = top;
				flake.x += o.wind;
				flake.life+= .01;
			}
			else {
				flake.html.style.top = -o.maxSize + "px";
				flake.x = o.random(o.WIDTH);
				flake.y = -o.maxSize;
				flake.html.style.left = flake.x + "px";
				flake.life = 0;
			}
		}
		setTimeout(function(){
			o.animate();
		},20);
	},

	random : function(range, num){
		var num = num?num:1;
		return Math.floor(Math.random() * (range + 1) * num) / num;
	},

	getSize : function(){
		this.WIDTH = document.body.clientWidth || window.innerWidth;
		this.HEIGHT = document.body.clientHeight || window.innerHeight;
	}

};
</script>' ;
        
		// Affiche le script
        return $html;
	}
} 
?> 